﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace AitoffProjection
{
    public partial class Form1 : Form
    {
        const int WIDTH = 1024;
        const int HEIGHT = WIDTH/2;

        const double STEP = 0.5;

        const int COLPAR = 15;  // <=23

        const int NSIDE = 12;

        

        public Form1()
        {
            InitializeComponent();
            this.Height = HEIGHT + 70;
            this.Width = WIDTH + 50;

        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            Graphics g = e.Graphics;

            Sphere.SCALE = HEIGHT / 2;
            g.TranslateTransform(this.ClientSize.Width / 2, this.ClientSize.Height / 2);


            float x, y;
            for (double DA = -180; DA <= 180.0; DA += STEP)
            {
                double A = Sphere.rad(DA);
                for (double DD = -90; DD <= 90.0; DD += STEP)
                {
                    double D = Sphere.rad(DD);
                    int K = HealPix.ang2pix_ring(NSIDE, A, D);
                    Sphere.Aitoff(DA, DD, out x, out y);
                    x *= -Sphere.SCALE;
                    y *= Sphere.SCALE;
                    Color color=Num2Color(K,COLPAR);
                    Brush b = new SolidBrush(color);
                    g.FillEllipse(b,x-1,y-1,3,3);
                }
            }

            Sphere.GridLines(g, 30.0);
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        static Color Num2Color(int M, int S)
        {
            Color J;
            int I, K;
            if (S < 23) K = S;
            else K = 23;
            I = M % K;
            switch (I)
            {
                case 0:
                    J = Color.FromArgb(127, 0, 0);
                    break;
                case 1:
                    J = Color.FromArgb(0, 127, 0);
                    break;
                case 2:

                    J = Color.FromArgb(0, 0, 127);
                    break;
                case 3:

                    J = Color.FromArgb(255, 0, 0);
                    break;
                case 4:

                    J = Color.FromArgb(0, 255, 0);
                    break;
                case 5:

                    J = Color.FromArgb(0, 0, 255);
                    break;
                case 6:

                    J = Color.FromArgb(127, 127, 0);
                    break;
                case 7:

                    J = Color.FromArgb(0, 127, 127);
                    break;
                case 8:

                    J = Color.FromArgb(127, 0, 127);
                    break;
                case 9:

                    J = Color.FromArgb(255, 255, 0);
                    break;
                case 10:

                    J = Color.FromArgb(0, 255, 255);
                    break;
                case 11:

                    J = Color.FromArgb(255, 0, 255);
                    break;
                case 12:

                    J = Color.FromArgb(255, 0, 127);
                    break;
                case 13:

                    J = Color.FromArgb(255, 127, 0);
                    break;
                case 14:

                    J = Color.FromArgb(127, 255, 0);
                    break;
                case 15:

                    J = Color.FromArgb(127, 0, 255);
                    break;
                case 16:

                    J = Color.FromArgb(0, 127, 255);
                    break;
                case 17:

                    J = Color.FromArgb(127, 127, 255);
                    break;
                case 18:

                    J = Color.FromArgb(127, 255, 127);
                    break;
                case 19:

                    J = Color.FromArgb(255, 127, 127);
                    break;
                case 20:

                    J = Color.FromArgb(127, 127, 127);
                    break;
                case 21:

                    J = Color.FromArgb(255, 255, 255);
                    break;
                case 22:
                    J = Color.FromArgb(0, 0, 0);
                    break;
                default:
                    J = Color.Black;
                    break;
            }

            return J;

        }


    }
}
