﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Text;

namespace AitoffProjection
{
    class Sphere
    {
        public static int SCALE = 1;

        public static double rad(double x)
        {
            return x / 180.0 * Math.PI;
        }

        public static void Aitoff(double l, double b, out float x, out float y)
        {
            l = rad(l); b = rad(b);
            double z = Math.Sqrt(1 + Math.Cos(b) * Math.Cos(l * 0.5));
            x = (float) (-2 * Math.Cos(b) * Math.Sin(l * 0.5) / z);
            y = (float) (-Math.Sin(b) / z);
         }

        public static void GridLines(Graphics dc, double Step)
        {
            float x, y; // Декартовы координаты
            float x0 = 0, y0 = 0;

            if (Step < 5) Step = 5;

            Font f = new Font("Arial", (float) (Math.Sqrt(Step)*3/2+5));

            //Color.FromArgb(0,0,0)
            
            for (double l = -180; l <= 180; l += Step)
            {
                for (double b = -90; b <= 90; b += 5)
                {
                    Aitoff(l, b, out x, out y);
                    x*= -SCALE;
                    y*= SCALE;
                    if (b != -90) dc.DrawLine(Pens.Black, x0, y0, x, y);
                    if (b == 0) dc.DrawString(l.ToString(), f, Brushes.Black, x, y);
                    x0 = x; y0 = y;
                }
            }

            for (double b = -90; b <= 90; b += Step)
            {
                
                for (double l = -180; l <= 180; l += 5)
                {
                    Aitoff(l, b, out x, out y);
                    x *= -SCALE;
                    y *= SCALE;
                    if (l != -180) dc.DrawLine(Pens.Red, x0, y0, x, y);
                    if (l == 0) dc.DrawString(b.ToString(), f, Brushes.Black, x, y);
                    x0 = x; y0 = y;
                }
            }

        }
    }
}
